<?php
/************************************************************
Program		Sorg Monitor
Filename	index.php
Version		1.01
Last update	08/10/2005
************************************************************/


// Include
require_once ('config.php');
require_once ('inc/inc_mysql.php');
require_once ('lang/'.$default_lang.'.php');

session_start();

// Inits
$err = 0;
$i = 0; 
$skip = 0;
$html = '<ul>';


if (($require_login == 1 || $require_login == 3) && $_SESSION['sorg_mon'] != $admin['username']) {
	header ('location: login.php');
	exit();
}
// Objet definitions
$db = new MySQL($db_access['host'], $db_access['database'], $db_access['username'], $db_access['password']);

//$q0 = $db->query('SELECT url, timestamp, sum(failure) AS failure, count(*) as count FROM data GROUP BY url ORDER BY url ASC');
$q0 = $db->query('SELECT url, max(timestamp) AS timestamp, sum(failure) AS tot_failure, count(timestamp) as count FROM data GROUP BY url, failure ORDER BY url ASC');

if (($no_req = $db->num_rows()) == 0) {
	echo ('<center><h2>'.$lang['out_of_range'].'</h2></center>');
	exit();
}


while ($i < $no_req || $skip == 1) {
	//$skip = 0;
	if ($skip == 0) {
		$var = $db->assoc($q0);
		$i++;
	} else {
		$var = $var2;
	}
	//$i++;
	$skip = 0;
	if ($var['tot_failure'] == $var['count'] || $i == $no_req) {
		$uptime = round(($var['count'] - $var['tot_failure']) * 100 / $var['count'], 1);
		if ($var['tot_failure'] > 0)
			$font_colour = 'red';
		else
			$font_colour = 'green';
		$tot_failure = $var['tot_failure'];
	} else {
		$var2 = $db->assoc($q0);
		$i++;
		if ($var2['url'] != $var['url']) {
			$skip = 1;
			$font_colour = 'green';
			$uptime = 100;
			$tot_failure = 0;
		} else {
			//$skip = 0;
			$uptime = round(($var['count'] + $var2['count'] - $var2['tot_failure']) * 100 / ($var['count'] + $var2['count']), 1);
			if ($var['timestamp'] < $var2['timestamp'])
				$font_colour = 'red';
			else
				$font_colour = 'green';
			$tot_failure = $var2['tot_failure'];
		}
	}
	$html .= '<li><b><a href="graph.php?url='.urlencode($var['url']).'" title="'.$lang['view_graph'].'">'.$var['url'].'</a> [<a href="delete.php?url='.urlencode($var['url']).'" title="'.$lang['del_from_db'].'">X</a>]</b><br />';
	$html .= '<span class="'.$font_colour.'text" title="'.$lang['host_'.$font_colour].'">'.$lang['uptime'].$uptime.'%, '.$lang['failed_req'].$tot_failure."</span></li>\n"; 
}

$html .= '</ul>';

// Meta refresh
if ($graph_refresh) {
	$meta_data = '<meta http-equiv="refresh" content="'.($graph_refresh * 60).';url='.$_SERVER['REQUEST_URI'].'">';
}

$q0 = $db->close();
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
<link rel="stylesheet" type="text/css" href="css/default.css" />
<?php echo ($meta_data); ?>
<title><?php echo ($lang['som']); ?></title>
</head>
<body>
<center><h2><?php echo ($lang['som']); ?></h2></center>
<?php echo ($html); ?>
</body>
</html>
